const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const journal_entries = sequelize.define(
    'journal_entries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

entry_number: {
        type: DataTypes.TEXT,
      
      

      },

entry_date: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"posted",


"void"

        ],

      },

memo: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  journal_entries.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

























    db.journal_entries.hasMany(db.journal_lines, {
      as: 'journal_lines_journal_entry',
      foreignKey: {
          name: 'journal_entryId',
      },
      constraints: false,
    });





//end loop



    db.journal_entries.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.journal_entries.belongsTo(db.bank_transactions, {
      as: 'source_bank_transaction',
      foreignKey: {
        name: 'source_bank_transactionId',
      },
      constraints: false,
    });



    db.journal_entries.hasMany(db.file, {
      as: 'attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.journal_entries.getTableName(),
        belongsToColumn: 'attachments',
      },
    });


    db.journal_entries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.journal_entries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return journal_entries;
};


